#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "npu2context4xi.py">
#<abstract4xi abstract = "NPU context management"/>
#<refer4xi reference = "context4xi.py"/>
#<verify4xi verification = "10" target = "npu2event4xi.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'NPU2Context4Xi',
            'create2context4npu',
            'get2context4npu',
            'release2context4npu',
            'retain2context4npu',
            'set2context4npu',
            'trace2context4npu'] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   

from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi

from platformids4xi import get2platformids4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global npu2context4xi                                                   # Context of NPU

global npu2trace4xi                                                     # TRACE

global fetch2code4npu                                                   # Fetched code

global import2use4npu                                                   # Imports of target function for Process4Xi

global kb2fetch4npu                                                     # Knowledgebase for fetching
global kb2kernel4npu                                                    # Knowledgebase for kernel   

global folder2lib4npu                                                   # Folder of NPU library

global profile2fetch                                                       # Profile knowledgebase for fetching
global keys2profile4npu

global target2function4npu                                              # Target function for Process4Xi
      
       
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

#"
#"/>
# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2context4npu" usage = "
#
#   task4create2npu = {}                                                                                            
#   task4create2npu= {}      
#   task4create2npu['FUNCTION2CALLBACK'] = trace2context4npu                                                   # CALLBACK FUNCTION CALLED BY NPUIZED OPENCL
# 
#   args2callback = {}                                                                                                          
#   args2callback['CLASS']   = "create2context4npu"                                                               # MODULE OF NPUIZED OPENCL MODULE
#   args2callback['METHOD']  = "create2context4npu"                                                               # FUNCTION OF NPUIZED OPENCL MODULE
#   args2callback['MESSAGE'] = "{(Step 2Z1/33) failed" + "; create2context4npu-failed " + "; time: " + time4xi() + "}"          # ERROR MESSAGE FOR NPUIZED OPENCL TO RETURN    
#   
#   task4create2npu['ARGS2CALLBACK'] = args2callback                                                              # MAX ONE ARG - THEREFORE GIVE SEVERAL ARGS IN ONE DICTIONARY 
#   
#   response4create2context = {}
#   print('(Step 1A/33) OF CONTEXT4XI5TEST - TRYING TO CREATE CONTEXT FOR NPU ', time4xi())  
#   try:                               
#       response4create2context = create2context4npu (task4create2context)                                        # EXAMINE RESPONSE!                                                      
#       print('(Step 1B/33) OF CONTEXT4XI5TEST - RESPONSE4CREATE2CONTEXT : ', response4create2context)               # trace2context4npu CALLED BY NPUIZED OPENCL IN EXCEPTIONS - CHECK NPUIZED TRACE!                       
#   except: 
#       print('(Step Z1/33) OF CONTEXT4XI5TEST *** FAILED TO CREARE CONTEXT FOR NPU ', time4xi())  
#
#">

# -------------------------------------------------------------------------------------------------   
def trace2context4npu(task4trace2npu=None):

    '''
    creates npu2context4xi
    '''
    
    global npu2trace4xi 
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2context4npu" 
    method2print = "trace2context4npu"

    message2print = "{(Step 1A/33) started" + "; trace2context4npu-started: " + str(trace2context4npu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # <function trace2context4npu at 0x00000000031898C8>  
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2npu-to-trace2context4npu: " + str(task4trace2npu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # {'MESSAGE': '{(Step 6Z1/33) failed; get2context4npu-failed ; time: 21:37:35 05/11/11 Pacific Daylight Time}', 
    #    'CLASS': 'get2context4npu', 
    #   'METHOD': 'get2context4npu'}; time: 22:50:59 05/11/11 Pacific Daylight Time}

    code2ack  = ' '
    code2nack = ' '    
    
    npu2trace4xi = {}                                                                                            # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2npu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY NPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2npu = {}                                                                                            
            
        task4trace2npu= {} 
  
        message2print = "{(Step 2A/33) warned" + "; task4trace2npu-warned-by-trace2context4npu to: " + str(task4trace2npu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
            
        code2nack = code2nack + '2A-'            

    else:
        # -----------------------------------------------------------------------------------------
        # PARAMETER GIVEN BY NPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------          
        message2print = "{(Step 3A/33) try" + "; task4trace2npu-try-by-trace2context4npu: " + str(task4trace2npu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # {'MESSAGE': '{(Step 6Z1/33) failed; get2context4npu-failed ; time: 21:37:35 05/11/11 Pacific Daylight Time}', 
        #    'CLASS': 'get2context4npu', 
        #   'METHOD': 'get2context4npu'}; time: 22:50:59 05/11/11 Pacific Daylight Time}

        try:
            class2print   = task4trace2npu['CLASS']                                                              # NPUIZE NPU TRACE!
            method2print  = task4trace2npu['METHOD']
            message2print = task4trace2npu['MESSAGE']
            print4xi(class2print, method2print, message2print)                                                      # NPUIZED TRACE FOR OPENCL CALLBACK!
            # =================================
            # { get2context4npu : get2context4npu ; (Step 6Z1/33) failed; get2context4npu-failed ; time: 21:37:35 05/11/11 Pacific Daylight Time}
            # =================================
            
            class2print = "trace2context4npu"                                                                    # SET TRACE BACK TO THIS FUNCTION!
            method2print = "trace2context4npu"                
            message2print = "{(Step 3B/33) performed" + "; npu-trace-performed-by-trace2context4npu: " + str(task4trace2npu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # npu-trace-performed-by-trace2context4npu: 
            # {'MESSAGE': '{(Step 6Z1/33) failed; get2context4npu-failed ; time: 21:37:35 05/11/11 Pacific Daylight Time}', 
            #    'CLASS': 'get2context4npu', 
            #   'METHOD': 'get2context4npu'}; time: 22:50:59 05/11/11 Pacific Daylight Time}

            code2ack = code2ack + '3B-' 
        except:
            message2print = "{(Step 3Z1/33) failed" + "; npu-trace-failed-by-trace2context4npu: " + str(task4trace2npu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                    
            code2nack = code2nack + '3Z1-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; trace2context4npu-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    # trace2context4npu-returning: 22:50:59 05/11/11 Pacific Daylight Time
    
    return
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2context4npu" usage = "
#     
#   context4xi = {}        
#   try:
#       context4xi['NPU'] = create2context4npu()                                                            # NPU context      
#       message2print = "{(Step 2B/33) initialized" + "; npu-context4xi-initialized-by-create2context4xi to: " + str(context4xi)  + "; time: " + time4xi() + "}" 
#       print4xi(class2print, method2print, message2print)     
#       ....                                                                                                      # context of devices
#   except:
#       message2print = "{(Step 3Z1/33) yielded" + "; context4xi-yielded-by-create2context4xi: " + str(context4xi) + "; time: " + time4xi() + "}"
#       print4xi(class2print, method2print, message2print)                                                              
#
#">

# -------------------------------------------------------------------------------------------------   
def create2context4npu(task4create2npu=None):

    '''
    creates npu2context4xi
    '''
    
    global npu2context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2context4npu" 
    method2print = "create2context4npu"

    message2print = "{(Step 1A/70) started" + "; create2context4npu-started: " + str(create2context4npu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2context4npu at 0x000000000339E948> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4create2npu-to-create2context4npu: " + str(task4create2npu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # None 

    code2ack  = ' '
    code2nack = ' '    
    
    npu2context4xi = {}                                                                                          # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4create2npu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - CREATE TASK CONTEXT
            # -----------------------------------------------------------------------------------------    
            task4create2npu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4create2npu-initialized-by-create2context4npu to: " + str(task4create2npu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            
            function2callback4npu = trace2context4npu                                                         # CALLBACK FUNCTION FOR NPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4npu-initialized-by-create2context4npu to: " + str(function2callback4npu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2context4npu at 0x000000000339E8C8>
            code2ack  = code2ack + '2A-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2context4npu"                                                      # MODULE OF NPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2context4npu"                                                      # FUNCTION OF NPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2context4npu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR NPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-initialized-by-create2context4npu to: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2context4npu-failed ; time: 20:18:34 05/11/11 Pacific Daylight Time}', 
            #    'CLASS': 'create2context4npu', 
            #   'METHOD': 'create2context4npu'}; time: 20:18:34 05/11/11 Pacific Daylight Time}

              
            task4create2npu['DATA2CALLBACK'] = args2callback                                                     # USER DATA PASSED TO NPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4create2npu['FUNCTION2CALLBACK'] = function2callback4npu                                      # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) set" + "; task4create2npu-initialized-by-create2context4npu to: " + str(task4create2npu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {  'NPU': {'FUNCTION2CALLBACK': <function trace2context4npu at 0x00000000031898C8>,
            #    'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4npu-failed ; time: 20:43:04 05/11/11 Pacific Daylight Time}', 
            #    'CLASS': 'create2context4npu', 'METHOD': 'create2context4npu'}}}; time: 20:43:04 05/11/11 Pacific Daylight Time}

            
            platform2xi = {}
            message2print = "{(Step 1G/70) initialized" + "; platform2xi-initialized-by-create2context4npu to: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # {}
            try:
                platform2xi = get2platformids4xi()
                message2print = "{(Step 1H/70) got" + "; platform2xi-got-by-create2context4npu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'available2platform': 1, 'max2entries': 1}
                code2ack  = code2ack + '2D-'
            except:
                message2print = "{(Step 1Z1/70) failed" + "; platform2xi-failed-by-create2context4npu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                         #
                 
            task4create2npu['PLATFORM'] = platform2xi                                                             # PLATFORM OF SYSTEM   
            task4create2npu['PROPERTIES'] = None                                                                  # CONTEXT PROPERTIES
            task4create2npu['INFO2PRIVATE'] = None                                                                # USED TO DEDUCE POINTER TO PRIVATE BINARY ERROR RETURNED BY OPENCL 
            task4create2npu['SIZE2PRIVATE'] = 0                                                                   # USED TO DEDUCE POINTER TO SIZE OF PRIVATE BINARY ERROR RETURNED BY OPENCL 
            
            task4create2npu ['COUNT2REFERENCE'] = 0                                                               # USED TO RETAIN(ATTACH) AND RELEASE CONTEXT 
              
            message2print = "{(Step 1I/70) created" + "; task4create2npu-initialized-by-create2context4npu to: " + str(task4create2npu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {  'NPU': {'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4npu-failed ; time: 20:43:04 05/11/11 Pacific Daylight Time}', 
            #            'CLASS': 'create2context4npu', 'METHOD': 'create2context4npu'}, 'FUNCTION2CALLBACK': <function trace2context4npu at 0x00000000031898C8>, 
            #            'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
            #            'SIZE2PRIVATE': 0, 'PROPERTIES': None}}; time: 20:43:04 05/11/11 Pacific Daylight Time}

                        
            code2ack  = code2ack + '2E-'
            
                         
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4create2npu-yielded-by-create2context4npu: " + str(task4create2npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '1Z2-' 

    npu2context4xi = {}                                                                                          # INITIALIZE NPU CONTEXT                                                                                      

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4create2npu.keys()        
    message2print = "{(Step 8/70) using" + "; keys2task-using-by-create2context4npu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 

    if 'PLATFORM' in keys2task:
        message2print = "{(Step 2A/70) try" + "; platform-try-by-create2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      
        # {}
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 2/70) - PLATFORM
            # -----------------------------------------------------------------------------------------               
            npu2context4xi['PLATFORM'] = task4create2npu['PLATFORM']
            
            message2print = "{(Step 2B/70) initialized" + "; platform-initialized-by-create2context4npu to: " + str(npu2context4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 20:55:51 05/11/11 Pacific Daylight Time}
            code2ack  = code2ack + '2B-'
        except: 
            message2print = "{(Step 2Z1/70) yielded" + "; platform-npu2context4xi-yielded-by-create2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z1-' 

    if 'PROPERTIES' in keys2task:            
        message2print = "{(Step 3A/70) try" + "; properties-try-by-create2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 3/70) - PROPERTIES
            # -----------------------------------------------------------------------------------------               
            npu2context4xi['PROPERTIES'] = task4create2npu['PROPERTIES']
            
            message2print = "{(Step 3B/70) initialized" + "; properties-initialized-by-create2context4npu to: " + str(npu2context4xi['PROPERTIES'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # None
            code2ack  = code2ack + '3B-'
        except: 
            message2print = "{(Step 3Z1/70) yielded" + "; properties-npu2context4xi-yielded-by-create2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '3Z1-' 

    if 'DATA2CALLBACK' in keys2task:        
        message2print = "{(Step 4A/70) try" + "; data2callback-try-by-create2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 4/70) - DATA2CALLBACK 
            # -----------------------------------------------------------------------------------------               
            npu2context4xi['DATA2CALLBACK'] = task4create2npu['DATA2CALLBACK']
            
            message2print = "{(Step 4B/70) initialized" + "; data2callback-initialized-by-create2context4npu to: " + str(npu2context4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2context4npu-failed ; time: 20:55:51 05/11/11 Pacific Daylight Time}', 
            #    'CLASS': 'create2context4npu', 
            #   'METHOD': 'create2context4npu'}; time: 20:55:51 05/11/11 Pacific Daylight Time}
    
            code2ack  = code2ack + '4B-'
        except: 
            message2print = "{(Step 4Z1/70) yielded" + "; data2callback-npu2context4xi-yielded-by-create2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '4Z1-'

    if 'INFO2PRIVATE' in keys2task:         
        message2print = "{(Step 5A/70) try" + "; info2private-try-by-create2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 5/70) - INFO2PRIVATE
            # -----------------------------------------------------------------------------------------               
            npu2context4xi['INFO2PRIVATE'] = task4create2npu['INFO2PRIVATE']
            
            message2print = "{(Step 5B/70) initialized" + "; info2private-initialized-by-create2context4npu to: " + str(npu2context4xi['INFO2PRIVATE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # None
            code2ack  = code2ack + '5B-'
        except: 
            message2print = "{(Step 5Z1/70) yielded" + "; info2private-npu2context4xi-yielded-by-create2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '5Z1-'         

    if 'SIZE2PRIVATE' in keys2task:    
        message2print = "{(Step 6A/70) try" + "; size2private-try-by-create2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 6/70) - SIZE2PRIVATE
            # -----------------------------------------------------------------------------------------               
            npu2context4xi['SIZE2PRIVATE'] = task4create2npu['SIZE2PRIVATE']
            
            message2print = "{(Step 6B/70) initialized" + "; size2private-initialized-by-create2context4npu to: " + str(npu2context4xi['SIZE2PRIVATE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            code2ack  = code2ack + '6B-'
        except: 
            message2print = "{(Step 6Z1/70) yielded" + "; size2private-npu2context4xi-yielded-by-create2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '6Z1-'

    if 'FUNCTION2CALLBACK' in keys2task:        
        message2print = "{(Step 7A/70) try" + "; function2callback-try-by-create2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 7/70) - FUNCTION2CALLBACK
            # -----------------------------------------------------------------------------------------               
            npu2context4xi['FUNCTION2CALLBACK'] = task4create2npu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 7B/70) initialized" + "; function2callback-initialized-by-create2context4npu to: " + str(npu2context4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function trace2context4npu at 0x00000000032098C8>
            code2ack  = code2ack + '7B-'
        except: 
            message2print = "{(Step 7Z1/70) yielded" + "; function2callback-npu2context4xi-yielded-by-create2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z1-'


    if 'COUNT2REFERENCE' in keys2task:        
        message2print = "{(Step 8A/70) try" + "; count2reference-try-by-create2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 8/70) - COUNT2REFERENCE
            # -----------------------------------------------------------------------------------------               
            npu2context4xi['COUNT2REFERENCE'] = task4create2npu['COUNT2REFERENCE']
            
            message2print = "{(Step 8B/70) initialized" + "; count2reference-initialized-by-create2context4npu to: " + str(npu2context4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '7B-'
        except: 
            message2print = "{(Step 8Z1/70) yielded" + "; count2reference-npu2context4xi-yielded-by-create2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z1-'        
                                                 
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    npu2context4xi ['ACK2RETURN']  = code2ack
    npu2context4xi ['NACK2RETURN'] = code2nack
    
    message2print = "{(Step 70/70) returning" + "; npu2context4xi-returning-by-create2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # {'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4npu-failed ; time: 20:55:51 05/11/11 Pacific Daylight Time}', 
    #          'CLASS': 'create2context4npu', 'METHOD': 'create2context4npu'}, 
    #  'FUNCTION2CALLBACK': <function trace2context4npu at 0x00000000032098C8>, 
    #         'ACK2RETURN': ' 2A2C2D2E2B3B4B5B6B7B', 
    #       'INFO2PRIVATE': None, 
    #           'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
    #        'NACK2RETURN': ' ', 
    #       'SIZE2PRIVATE': 0, 
    #         'PROPERTIES': None
    # }; time: 20:55:51 05/11/11 Pacific Daylight Time}
 

    
    return npu2context4xi
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2context4npu" usage = "
#
#   # Example (from context4xi.py - task4set2context got as parameter - see context4xi5test.py)
#
#   if context4xi is None:
#       context4xi = create2context4xi()                                                                          # CREATE CONTEXT4XI
#   try:
#       # -----------------------------------------------------------------------------
#       # (Step 4A/33)
#       # ----------------------------------------------------------------------------- 
#       message2print = "{(Step 4A/33) passing" + "; task-passing-to-set2context4npu: " + str(task4set2context['NPU'])  + "; time: " + time4xi() + "}"  
#       print4xi(class2print, method2print, message2print)                                                         
#          
#       context4xi ['NPU'] = set2context4npu(task4set2context['NPU'])                                        # 
#            
#       message2print = "{(Step 4B/33) set" + "; npu-context-set-by-set2context4npu to: " + str(context4xi ['NPU'])  + "; time: " + time4xi() + "}"
#       print4xi(class2print, method2print, message2print)                                                          
#       code2ack  = code2ack + '4B-'
#   except:
#       message2print = "{(Step 4Z1/33) yielded" + "; npu-yielded-by-set2context4xi: " + 'NPU' + "; time: " + time4xi() + "}"
#       print4xi(class2print, method2print, message2print) 
#       code2nack  = code2nack + '4Z1-'
#">

# -------------------------------------------------------------------------------------------------   
def set2context4npu(task4set2npu=None):

    '''
    sets npu2context4xi
    '''
    global npu2context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2context4npu"
    method2print = "set2context4npu"

    message2print = "{(Step 1A/33) started" + "; set2context4npu-started: " + str(set2context4npu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2context4npu at 0x000000000331CD48>
    
    message2print = "{(Step 1B/33) passed" + "; task4set2npu-to-set2context4npu: " + str(task4set2npu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4npu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 'CLASS': 'get2context4npu', 'METHOD': 'get2context4xi4npu'}, 
    #  'ARGS2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4npu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 'CLASS': 'get2context4npu', 'METHOD': 'get2context4xi4npu'}, 
    #  'FUNCTION2CALLBACK': <function trace2context4npu at 0x000000000331CC48>, 'INFO2PRIVATE': None, 
    #           'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
    #       'SIZE2PRIVATE': 0, 
    #         'PROPERTIES': None
    #}; time: 23:20:05 05/11/11 Pacific Daylight Time}

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if npu2context4xi is None:
            npu2context4xi = create2context4npu()                                                             # INITIALIZE CONTEXT FOR NPU                      
    except:
        try:
            npu2context4xi = create2context4npu()
        except:
            npu2context4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; npu2context4xi-yielded-by-set2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 2A/70) try" + "; platform-try-by-set2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 2/70) - PLATFORM (DIRECT TRANSFER FROM INPUT TRIED - AS WITH OTHERS)
        # -----------------------------------------------------------------------------------------               
        npu2context4xi['PLATFORM'] = task4set2npu['PLATFORM']
        
        message2print = "{(Step 2B/70) set" + "; platform-set-by-set2context4npu to: " + str(npu2context4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 23:20:05 05/11/11 Pacific Daylight Time}

        code2ack  = code2ack + '2B-'
    except: 
        message2print = "{(Step 2Z1/70) yielded" + "; platform-npu2context4xi-yielded-by-set2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '2Z1-' 
        
    message2print = "{(Step 3A/70) try" + "; properties-try-by-set2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 3/70) - PROPERTIES
        # -----------------------------------------------------------------------------------------               
        npu2context4xi['PROPERTIES'] = task4set2npu['PROPERTIES']
        
        message2print = "{(Step 3B/70) set" + "; properties-set-by-set2context4npu to: " + str(npu2context4xi['PROPERTIES'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # None
        code2ack  = code2ack + '3B-'
    except: 
        message2print = "{(Step 3Z1/70) yielded" + "; properties-npu2context4xi-yielded-by-set2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '3Z1-' 
        
    message2print = "{(Step 4A/70) try" + "; data2callback-try-by-set2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 4/70) - DATA2CALLBACK
        # -----------------------------------------------------------------------------------------               
        npu2context4xi['DATA2CALLBACK'] = task4set2npu['DATA2CALLBACK']
        
        message2print = "{(Step 4B/70) set" + "; data2callback-set-by-set2context4npu to: " + str(npu2context4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'MESSAGE': '{(Step 6Z1/33) failed; get2context4npu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 
        #    'CLASS': 'get2context4npu', 
        #   'METHOD': 'get2context4xi4npu'}; time: 23:20:05 05/11/11 Pacific Daylight Time}

        code2ack  = code2ack + '4B-'
    except: 
        message2print = "{(Step 4Z1/70) yielded" + "; data2callback-npu2context4xi-yielded-by-set2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '4Z1-'
         
    message2print = "{(Step 5A/70) try" + "; info2private-try-by-set2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 5/70) - INFO2PRIVATE
        # -----------------------------------------------------------------------------------------               
        npu2context4xi['INFO2PRIVATE'] = task4set2npu['INFO2PRIVATE']
        
        message2print = "{(Step 5B/70) set" + "; info2private-set-by-set2context4npu to: " + str(npu2context4xi['INFO2PRIVATE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # None
        code2ack  = code2ack + '5B-'
    except: 
        message2print = "{(Step 5Z1/70) yielded" + "; info2private-npu2context4xi-yielded-by-set2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '5Z1-'         
    
    message2print = "{(Step 6A/70) try" + "; size2private-try-by-set2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)           
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 6/70) - SIZE2PRIVATE
        # -----------------------------------------------------------------------------------------               
        npu2context4xi['SIZE2PRIVATE'] = task4set2npu['SIZE2PRIVATE']
        
        message2print = "{(Step 6B/70) set" + "; size2private-set-by-set2context4npu to: " + str(npu2context4xi['SIZE2PRIVATE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0
        code2ack  = code2ack + '6B-'
    except: 
        message2print = "{(Step 6Z1/70) yielded" + "; size2private-npu2context4xi-yielded-by-set2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '6Z1-'
        
    message2print = "{(Step 7A/70) try" + "; function2callback-try-by-set2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    # {'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4npu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 'CLASS': 'get2context4npu', 'METHOD': 'get2context4xi4npu'}, 'FUNCTION2CALLBACK': <function trace2context4npu at 0x000000000331CC48>, 'ACK2RETURN': ' 2A2C2D2E2B3B4B5B6B7B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 23:20:05 05/11/11 Pacific Daylight Time}

    try:
        # -----------------------------------------------------------------------------------------
        # (Step 7/70) - FUNCTION2CALLBACK
        # -----------------------------------------------------------------------------------------               
        npu2context4xi['FUNCTION2CALLBACK'] = task4set2npu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 7B/70) set" + "; function2callback-set-by-set2context4npu to: " + str(npu2context4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # <function trace2context4npu at 0x000000000331CC48>
        code2ack  = code2ack + '7B-'
    except: 
        message2print = "{(Step 7Z1/70) yielded" + "; function2callback-npu2context4xi-yielded-by-set2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '7Z1-'


    try:
        # -----------------------------------------------------------------------------------------
        # (Step 8/70) - COUNT2REFERENCE
        # -----------------------------------------------------------------------------------------               
        npu2context4xi['COUNT2REFERENCE'] = task4set2npu['COUNT2REFERENCE']
        
        message2print = "{(Step 8B/70) set" + "; count2reference-set-by-set2context4npu to: " + str(npu2context4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '8B-'
    except: 
        message2print = "{(Step 8Z1/70) yielded" + "; count2reference-npu2context4xi-yielded-by-set2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '8Z1-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    npu2context4xi ['ACK2RETURN']  = code2ack
    npu2context4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; npu2context4xi-returning-by-set2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # npu2context4xi-returning-by-set2context4npu: 
    #  {'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4npu-failed ; time: 23:20:05 05/11/11 Pacific Daylight Time}', 
    #                       'CLASS': 'get2context4npu', 
    #                      'METHOD': 'get2context4xi4npu'}, 
    #   'FUNCTION2CALLBACK': <function trace2context4npu at 0x000000000331CC48>, 
    #          'ACK2RETURN': ' 2B3B4B5B6B7B', 
    #        'INFO2PRIVATE': None, 
    #            'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
    #         'NACK2RETURN': ' ', 
    #        'SIZE2PRIVATE': 0, 
    #          'PROPERTIES': None
    # }; time: 23:20:05 05/11/11 Pacific Daylight Time}

    return npu2context4xi

            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2context4npu" usage = "
#
#   # Example (see context4xi5test.py)
#   # (19) REFERENCE COUNT FOR EACH PROCESSING UNIT RELEASED BY DECRENTING COUNT WITH 1             
#   task4release2context = {}
#   task4release2context ['NPU'] = {} 
#    
#   task4release2context ['NPU'] ['COUNT2REFERENCE'] = 1                                                            # REFERENCE COUNT
#   response4release2context = {}
#   
#   print('(Step 5A/33) OF CONTEXT4XI5TEST - TRYING TO RELEASE CONTEXT OF NPU DEVICE ', time4xi())  
#   try:                               
#       response4release2context = release2context4xi(task4release2context)                                         # COUNT2REFERENCE                                                      
#       print('(Step 5BD/33) OF CONTEXT4XI5TEST - RESPONSE4RELEASE2CONTEXT : ', response4release2context)                          
#       
#   except:
#       print('(Step 5Z1/33) OF CONTEXT4XI5TEST *** FAILED TO RELEASE CONTEXT OF NPU DEVICE ', time4xi())  
#">

# -------------------------------------------------------------------------------------------------   
def release2context4npu(task4release2npu=None):

    '''
    releases npu2context4xi
    '''
    global npu2context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2context4npu"
    method2print = "release2context4npu" 

    message2print = "{(Step 1A/33) started" + "; release2context4npu-started: " + str(release2context4npu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function release2context4npu at 0x0000000003361348> 
    
    message2print = "{(Step 1B/33) passed" + "; task4release2npu-to-release2context4npu: " + str(task4release2npu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'COUNT2REFERENCE': 1}

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if npu2context4xi is None:
            npu2context4xi = create2context4npu()                                                             # INITIALIZE CONTEXT                 
    except:
        try:
            npu2context4xi = create2context4npu()
        except:
            npu2context4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; npu2context4xi-yielded-by-release2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2npu is None:
        task4release2npu = {}
        task4release2npu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        npu2context4xi['COUNT2REFERENCE'] = npu2context4xi['COUNT2REFERENCE'] - task4release2npu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2context4npu: " + str(npu2context4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0
         
        if npu2context4xi['COUNT2REFERENCE'] < 0:
            npu2context4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2context4npu: " + " ** " + str(npu2context4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
                
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            npu2context4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2context4npu: " + " ** " + str(npu2context4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; npu2context4xi-yielded-by-release2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    npu2context4xi ['ACK2RETURN']  = code2ack
    npu2context4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; npu2context4xi-returning-by-release2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4npu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4npu', 'METHOD': 'get2context4xi4npu'}, 'FUNCTION2CALLBACK': <function trace2context4npu at 0x00000000033611C8>, 'ACK2RETURN': ' 1B', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 04:03:17 05/15/11 Pacific Daylight Time}
 
    
    return npu2context4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2context4npu" usage = "
#
#   # Example (see context4xi5test.py)
#   # (19) REFERENCE COUNT FOR EACH PROCESSING UNIT RETAIND BY INCREMENTING COUNT WITH 1             
#   task4retain2context = {}
#   task4retain2context ['NPU'] = {} 
#    
#   task4retain2context ['NPU'] ['COUNT2REFERENCE'] = 1                  # ADD REFERENCE COUNT BY 1
#   response4retain2context = {}
#   
#   print('(Step 5A/33) OF CONTEXT4XI5TEST - TRYING TO RETAIN CONTEXT OF NPU DEVICE ', time4xi())  
#   try:                               
#       response4retain2context = retain2context4xi(task4retain2context)                                                                                          
#       print('(Step 5BD/33) OF CONTEXT4XI5TEST - RESPONSE4RETAIN2CONTEXT : ', response4retain2context)                          
#       
#   except:
#       print('(Step 5Z1/33) OF CONTEXT4XI5TEST *** FAILED TO RETAIN CONTEXT OF NPU DEVICE ', time4xi())  
#">

# -------------------------------------------------------------------------------------------------   
def retain2context4npu(task4retain2npu=None):

    '''
    retains npu2context4xi
    '''
    global npu2context4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2context4npu"
    method2print = "retain2context4npu"

    message2print = "{(Step 1A/33) started" + "; retain2context4npu-started: " + str(retain2context4npu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2npu-to-retain2context4npu: " + str(task4retain2npu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if npu2context4xi is None:
            npu2context4xi = create2context4npu()                                                             # INITIALIZE CONTEXT                 
    except:
        try:
            npu2context4xi = create2context4npu()
        except:
            npu2context4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; npu2context4xi-yielded-by-retain2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; retain-try-by-retain2context4npu: " + str(npu2context4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
           
    try:
        # -----------------------------------------------------------------------------------------
        # RETAIN
        # -----------------------------------------------------------------------------------------               
        npu2context4xi['COUNT2REFERENCE'] = npu2context4xi['COUNT2REFERENCE'] + task4retain2npu['COUNT2REFERENCE']
        
        message2print = "{(Step 1C/70) calculated" + "; count2reference-calculated-by-retain2context4npu: " + str(npu2context4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #
         
        if npu2context4xi['COUNT2REFERENCE'] <= 0:
            npu2context4xi['COUNT2REFERENCE'] = 1
            
            message2print = "{(Step 1D/70) warning" + "; count2reference-warning-by-retain2context4npu: " + " ** " + str(npu2context4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
                
            code2nack  = code2nack + '1D-'
        else:
            code2ack  = code2ack + '1D-'
    except:
        try:
            npu2context4xi['COUNT2REFERENCE'] = 1
            
            message2print = "{(Step 1Z1/70) warning" + "; count2reference-warning-by-retain2context4npu: " + " ** " + str(npu2context4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '1Z1-'
            
        except:
            message2print = "{(Step 1Z2/70) yielded" + "; npu2context4xi-yielded-by-retain2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    npu2context4xi ['ACK2RETURN']  = code2ack
    npu2context4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; npu2context4xi-returning-by-retain2context4npu: " + str(npu2context4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    #  {'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 6Z1/33) failed; get2context4npu-failed ; time: 04:03:17 05/15/11 Pacific Daylight Time}', 'CLASS': 'get2context4npu', 'METHOD': 'get2context4xi4npu'}, 'FUNCTION2CALLBACK': <function trace2context4npu at 0x00000000033611C8>, 'ACK2RETURN': ' 1D', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 04:03:17 05/15/11 Pacific Daylight Time}

    
    return npu2context4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2context4npu" usage = "
#
#   try:                               
#       response4get2npu = get2context4npu()                                        
#                                                                                                                   
#   except:
#       ... 
#                          
#">

# -------------------------------------------------------------------------------------------------   
def get2context4npu():

    '''
    gets npu2context4xi
    '''
    
    global npu2context4xi
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2context4npu"
    method2print = "get2context4npu"

    message2print = "{(Step 1A/33) started" + "; get2context4npu-started: " + str(get2context4npu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function get2context4npu at 0x000000000323E048>                                                              
    try: 
        if npu2context4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            npu2xi = create2context4npu()
            message2print = "{(Step 1B/33) initialized" + "; npu2xi-initialized-by-get2context4npu to: " + str(npu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  
        else:
            # -------------------------------------------------------------------------------------
            # RETURN THE EXISTING CONTEXT FOR NPU          
            # -------------------------------------------------------------------------------------     
            npu2xi = npu2context4xi
            message2print = "{(Step 1C/33) got" + "; npu2xi-got-by-get2context4npu: " + str(npu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            npu2xi = create2context4npu()
            
            message2print = "{(Step 1D/33) initialized" + "; npu2xi-initialized-by-get2context4npu to: " + str(npu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4npu-failed ; time: 08:44:09 05/19/11 Pacific Daylight Time}', 
            #             'CLASS': 'create2context4npu', 'METHOD': 'create2context4npu'}, 
            # 'FUNCTION2CALLBACK': <function trace2context4npu at 0x0000000003230D48>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 
            # 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
            # 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 08:44:09 05/19/11 Pacific Daylight Time}
               
            
        except:
            npu2xi = {}            
            message2print = "{(Step 1Z2/70) yielded" + "; npu2xi-yielded-by-retain2context4npu: " + str(npu2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                    
    message2print = "{(Step 33/33) returning" + "; npu2xi-returning-by-get2context4npu: " + str(npu2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4npu-failed ; time: 04:14:11 05/21/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4npu', 'METHOD': 'create2context4npu'}, 'FUNCTION2CALLBACK': <function trace2context4npu at 0x00000000037AE448>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 04:14:11 05/21/11 Pacific Daylight Time}
  
    
    return npu2xi
            
#</function4xi> 
 
                                               
# =================================================================================================
#<class4xi class = "NPU2Context4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for NPU context" usage = "Context4Xi of NPU"
#>

# =================================================================================================
class NPU2Context4Xi(object): 
    ''' 
    NPU2Context4Xi offers  methods for NPU context
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2npu = None
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
    'create2npu',
    'get2npu',
    'release2npu',
    'retain2npu',
    'set2npu',
    'sense',
    'reason',
    'ace')          
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-NPU2Context4Xi" usage = "
    # try:
    #     # ---------------------------------------------------------------------------------------------
    #     # CREATE OBJECT                        
    #     # ---------------------------------------------------------------------------------------------        
    #     cc2xi = NPU2Context4Xi()
    #     print('(Step 5B/33) OF NPU4XI5TEST - CREATED NPU2Context4Xi OBJECT: ', cc2xi)                                       
    # except:
    #     print('(Step 5Z/33) OF NPU4XI5TEST *** FAILED TO CREATE NPU2Context4Xi OBJECT')
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4create2npu = None):
        '''
        _init__ method initializes NPU2Context4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "NPU2Context4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-NPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 

        message2print = "{(Step 1B/33) borning" + "; npu2context2xi-of-NPU2Context4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #   
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-npu2context2xi-of-NPU2Context4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #   
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2npu-sharing-by-npu2context2xi-of-NPU2Context4Xi: " + str(NPU2Context4Xi.classvariable2npu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #                
                                
        message2print = "{(Step 1E/33) passed" + "; task4create2npu-passed-to-init-of-NPU2Context4Xi: " + str(task4create2npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #                               
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) passing" + "; task4create2npu-passing-to-create2context4npu-by-init-of-NPU2Context4Xi: " + str(task4create2npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #  
        
        npu2context2xi = create2context4npu(task4create2npu)
        
        message2print = "{(Step 2B/33) performed" + "; create2context4npu-performed-by-init-of-NPU2Context4Xi: " + str(create2context4npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #  
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; npu2context2xi-of-NPU2Context4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-npu2context2xi-of-NPU2Context4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2npu-shared-by-npu2context2xi-of-NPU2Context4Xi: " + str(NPU2Context4Xi.classvariable2npu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #               
       
        message2print = "{(Step 3D/33) returning" + "; init-of-NPU2Context4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create-of-NPU2Context4Xi" usage = "
    # print('(Step 1A/33) OF NPU2CONTEXT4XI - TRYING TO CREATE NPU CONTEXT')
    # try:
    #     cc2xi = NPU2Context4Xi()                            
    #     context2npu = cc2xi.create2npu()                                  
    #     print('(Step 1B/33) OF NPU4XI5TEST - SET NPU CONTEXT: ', context2npu)                                                  
    # except:
    #     print('(Step 1Z/33) OF NPU4XI5TEST *** FAILED TO SET NPU CONTEXT ***')
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2npu(self, task4create2npu = None):
        '''
        create2npu method creates objects of NPU2Context4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "NPU2Context4Xi"
        method2print = "create2npu"
                     
        message2print = "{(Step 1A/33) started" + "; create2npu-of-NPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4create2npu-passed-to-create2npu-of-NPU2Context4Xi: " + str(task4create2npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4create2npu-passing-to-create2context4npu-by-create2npu-of-NPU2Context4Xi: " + str(task4create2npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
  
        npu2context2xi = create2context4npu(task4create2npu)

        message2print = "{(Step 2B/33) performed" + "; create2context4npu-performed-by-create2npu-of-NPU2Context4Xi: " + str(create2context4npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; npu2context2xi-returning-by-create2npu-of-NPU2Context4Xi: " + str(npu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
 
                
        return npu2context2xi
                                
    #                        
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2npu-of-NPU2Context4Xi" usage = "
    # print('(Step 1A/33) OF NPU2CONTEXT4XI - TRYING TO SET NPU CONTEXT')
    # try:
    #     cc2xi = NPU2Context4Xi()                            
    #     context2npu = cc2xi.set2npu()                                  
    #     print('(Step 1B/33) OF NPU4XI5TEST - SET NPU CONTEXT: ', context2npu)                                                  
    # except:
    #     print('(Step 1Z/33) OF NPU4XI5TEST *** FAILED TO SET NPU CONTEXT ***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2npu(self, task4set2npu = None):
        '''
        sets NPU2Context4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "NPU2Context4Xi"
        method2print = "set2npu"
                     
        message2print = "{(Step 1A/33) started" + "; set2npu-of-NPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4set2npu-passed-to-set2npu-of-NPU2Context4Xi: " + str(task4set2npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2npu-passing-to-set2context4npu-by-set2npu-of-NPU2Context4Xi: " + str(task4set2npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        npu2context2xi = set2context4npu(task4set2npu)

        message2print = "{(Step 2B/33) performed" + "; set2context4npu-performed-by-set2npu-of-NPU2Context4Xi: " + str(set2context4npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; npu2context2xi-returning-by-set2npu-of-NPU2Context4Xi: " + str(npu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return npu2context2xi
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2npu-of-NPU2Context4Xi" usage = "
    # print('(Step 1A/33) OF NPU2CONTEXT4XI - TRYING TO GET NPU CONTEXT')
    # try:
    #     cc2xi = NPU2Context4Xi()                            
    #     context2npu = cc2xi.get2npu()                                  
    #     print('(Step 1B/33) OF NPU4XI5TEST - GOT NPU CONTEXT: ', context2npu)                                                  
    # except:
    #     print('(Step 1Z/33) OF NPU4XI5TEST *** FAILED TO GET NPU CONTEXT ***')   
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2npu(self):
        '''
        get2npu method gets objects of NPU2Context4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "NPU2Context4Xi"
        method2print = "get2npu"
                     
        message2print = "{(Step 1A/33) started" + "; get2npu-of-NPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        npu2context2xi = get2context4npu()
        
        message2print = "{(Step 2A/33) returning" + "; npu2context2xi-returning-by-get2npu-of-NPU2Context4Xi: " + str(npu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                
        return npu2context2xi
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2npu-of-NPU2Context4Xi" usage = "
    # print('(Step 1A/33) OF NPU2CONTEXT4XI - TRYING TO SET NPU CONTEXT')
    # try:
    #     cc2xi = NPU2Context4Xi()                            
    #     context2npu = cc2xi.release2npu()                                  
    #     print('(Step 1B/33) OF NPU4XI5TEST - SET NPU CONTEXT: ', context2npu)                                                  
    # except:
    #     print('(Step 1Z/33) OF NPU4XI5TEST *** FAILED TO SET NPU CONTEXT ***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release2npu(self, task4release2npu = None):
        '''
        releases NPU2Context4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "NPU2Context4Xi"
        method2print = "release2npu"
                     
        message2print = "{(Step 1A/33) started" + "; release2npu-of-NPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4release2npu-passed-to-release2npu-of-NPU2Context4Xi: " + str(task4release2npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2npu-passing-to-release2context4npu-by-release2npu-of-NPU2Context4Xi: " + str(task4release2npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        npu2context2xi = release2context4npu(task4release2npu)

        message2print = "{(Step 2B/33) performed" + "; release2context4npu-performed-by-release2npu-of-NPU2Context4Xi: " + str(release2context4npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; npu2context2xi-returning-by-release2npu-of-NPU2Context4Xi: " + str(npu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return npu2context2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2npu-of-NPU2Context4Xi" usage = "
    # print('(Step 1A/33) OF NPU2CONTEXT4XI - TRYING TO SET NPU CONTEXT')
    # try:
    #     cc2xi = NPU2Context4Xi()                            
    #     context2npu = cc2xi.retain2npu()                                  
    #     print('(Step 1B/33) OF NPU4XI5TEST - SET NPU CONTEXT: ', context2npu)                                                  
    # except:
    #     print('(Step 1Z/33) OF NPU4XI5TEST *** FAILED TO SET NPU CONTEXT ***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2npu(self, task4retain2npu = None):
        '''
        retains NPU2Context4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "NPU2Context4Xi"
        method2print = "retain2npu"
                     
        message2print = "{(Step 1A/33) started" + "; retain2npu-of-NPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4retain2npu-passed-to-retain2npu-of-NPU2Context4Xi: " + str(task4retain2npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain2npu-passing-to-retain2context4npu-by-retain2npu-of-NPU2Context4Xi: " + str(task4retain2npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        npu2context2xi = retain2context4npu(task4retain2npu)

        message2print = "{(Step 2B/33) performed" + "; retain2context4npu-performed-by-retain2npu-of-NPU2Context4Xi: " + str(retain2context4npu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; npu2context2xi-returning-by-retain2npu-of-NPU2Context4Xi: " + str(npu2context2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return npu2context2xi
                                                           
    #</methodize4xi>   
                                         
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-NPU2Context4Xi" usage = "
    # try:
    #     print(cc2xi.sense())
    # 
    #     print('=' *33)          
    #     print('(Step 15B/33) OF NPU4XI5TEST - SENSED ', time4xi())                                                  
    #                                                                                                                 
    #     print('=' *33)
    # except:
    #     print('(Step 15Z/33) OF NPU4XI5TEST *** FAILED TO SENSE ', time4xi())    
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses NPU2Context4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'NPU2Context4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-NPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; NPU2Context4Xi-sensing-by-sense-of-NPU2Context4Xi: " + str(NPU2Context4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-NPU2Context4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2npu-of-NPU2Context4Xi'] = NPU2Context4Xi.classvariable2npu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-NPU2Context4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; NPU2Context4Xi-sensed-by-sense-of-NPU2Context4Xi: " + str(NPU2Context4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-NPU2Context4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #                    
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-NPU2Context4Xi" usage = "
    # try:
    #     print(cc2xi.reason())
    # 
    #     print('=' *33)          
    #     print('(Step 17B/33) OF NPU4XI5TEST - REASONED ', time4xi())                                                
    #     print('=' *33)       
    # except:
    #     print('(Step 17Z/33) OF NPU4XI5TEST *** FAILED TO REASON ', time4xi())     
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons NPU2Context4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'NPU2Context4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-NPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; NPU2Context4Xi-reasoning-by-reason-of-NPU2Context4Xi: " + str(NPU2Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-NPU2Context4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-NPU2Context4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-NPU2Context4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; NPU2Context4Xi-reasoned-by-reason-of-NPU2Context4Xi: " + str(NPU2Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-NPU2Context4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #                     
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-NPU2Context4Xi" usage = "
    # try:
    #     print(cc2xi.ace())
    # 
    #     print('=' *33)          
    #     print('(Step 21B/33) OF NPU4XI5TEST - ACED ', time4xi())                                                    
    #     print('=' *33) 
    # except:
    #     print('(Step 21Z/33) OF NPU4XI5TEST *** FAILED TO ACE ', time4xi())      
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces NPU2Context4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'NPU2Context4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-NPU2Context4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; NPU2Context4Xi-acing-by-ace-of-NPU2Context4Xi: " + str(NPU2Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-NPU2Context4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-NPU2Context4Xi'] = NPU2Context4Xi.classvariable2npu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-NPU2Context4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; NPU2Context4Xi-aced-by-ace-of-NPU2Context4Xi: " + str(NPU2Context4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-NPU2Context4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   npu2event4xi5test.txt
#   sense-npu2event4xi5test.xml
#   reason-npu2event4xi5test.xml
#   ace-npu2event4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of npu2context4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
